#Cynthia Taylor
#Process Pools

from multiprocessing import *
import time

#add up the numbers from 0 . . . n

def sumnums(L):
    start = L[0]
    end = L[1]
    total = 0
    for i in range(start,end):
        total = total + i
    return total

n = 10000000

start = time.clock()
total = sumnums([0,n+1])
end = time.clock()
print(total,end-start)

start = time.clock()
pool = Pool(processes=4)
results = pool.map(sumnums,[[0,n//4],[n//4,n//2],[n//2, 3*n//4],[3*n//4,n+1]])


total = 0
for e in results:
    total = total + e
    
end = time.clock()
print("Total sum is", total, end-start)

startclock = time.clock()
pool = Pool(processes=100)


start = 0
end = n//100
L = [[start,end]]
for i in range(100):
    start = start + n//100
    end = end+ n//100
    L.append([start,end])

results = pool.map(sumnums,L)


total = 0
for e in results:
    total = total + e
    
endclock = time.clock()
print("Total sum is", total, endclock-startclock)